package cz.frantovo.nekurak.ext;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

/**
 * Neprovádí vlastní interpretaci Texy syntaxe, ale volá HTTP službu napsanou v PHP.
 * @author fiki
 */
public class Texy {

    /** TODO: parametrizovatelnost/localhost ? */
    private static final String URL_SLUZBY = "http://nekurak.net/texy/http/";

    public String preved(String text) {
	try {
	    URL url = new URL(URL_SLUZBY);
	    URLConnection spojeni = url.openConnection();
	    spojeni.setDoOutput(true);

	    /** Odešleme data */
	    OutputStreamWriter wr = new OutputStreamWriter(spojeni.getOutputStream());
	    wr.write(URLEncoder.encode(text, "UTF-8"));
	    wr.flush();

	    /** Přijmeme odpověď */
	    BufferedReader rd = new BufferedReader(new InputStreamReader(spojeni.getInputStream()));
	    StringBuffer vysledek = new StringBuffer();
	    String radka;
	    while ((radka = rd.readLine()) != null) {
		vysledek.append(radka);
	    }

	    // TODO: → finally
	    wr.close();
	    rd.close();

	    return vysledek.toString();
	} catch (Exception e) {
	    return "TODO:chyba";
	} finally {
	    // TODO
	}
    }
}
