<?xml version="1.0" encoding="UTF-8"?>
<jsp:root xmlns:jsp="http://java.sun.com/JSP/Page"
	  xmlns:c="http://java.sun.com/jsp/jstl/core"
	  xmlns:fmt="http://java.sun.com/jsp/jstl/fmt"
	  xmlns:fn="http://java.sun.com/jsp/jstl/functions"
	  xmlns:nk="urn:jsptagdir:/WEB-INF/tags/nekurak"
	  version="2.0">

    <jsp:useBean id="detail" class="cz.frantovo.nekurak.web.Detail" scope="request"/>

    <jsp:setProperty name="detail" property="id" value="${param.podnik}"/>

    <nk:stranka titulek="${fn:escapeXml(detail.podnik.nazev)}">

	<h1><c:out value="${detail.podnik.nazev}" /></h1>


	<c:choose>
	    <c:when test="${detail.mapa == null}">
		<p>
		    Souřadnice tohoto podniku nejsou známé.<br/>
		    (možná ještě nebyl proveden jejich výpočet)
		</p>
	    </c:when>
	    <c:otherwise>
		<p>
		    Zeměpisná šířka: ${detail.podnik.sirka}<br/>
		    Zeměpisná délka: ${detail.podnik.delka}<br/>
		    Loc: ${detail.podnik.sirka}, ${detail.podnik.delka}<br/>
		</p>
		<p>
		    <img alt="mapa" src="${fn:escapeXml(detail.mapa)}"/>
		</p>
	    </c:otherwise>
	</c:choose>



    </nk:stranka>

</jsp:root>
